<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 21/09/2016
 * Time: 17:11
 */

namespace ByDedi\AdminBundle\Form\Type;

use Symfony\Component\DependencyInjection\Container;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AjaxCollectionType extends AbstractType
{
    private $container;
    /**
     * @param EntityManager
     */
    public function __construct(Container $container)
    {
        $this->container = $container;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'hide_columns' => [],
            'btn_add' => true,
            'mapped' => false,
            'query_string',
        ]);
    }

    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $admin = $this->container->get($options['admin_service']);
        $view->vars['admin'] = $admin;
        $listUrl = $admin->generateUrl(
            'sublist',
            array_merge(
                $view->vars['sonata_admin']['field_description']->getOption('link_parameters', []),
                ['origin_id' => $view->vars['sonata_admin']['admin']->getSubject()->getId(),
                    'pcode' => $view->vars['sonata_admin']['admin']->getCode(),
                    '_list_mode' => 'list']
            )
        );
        $view->vars['listUrl'] = $listUrl;
        $view->vars['btn_add'] = $options['btn_add'];
        $view->vars['pcode'] = $view->vars['sonata_admin']['admin']->getCode();
    }

    public function getBlockPrefix()
    {
        return 'ajax_collection_type';
    }
}
